--- old/usr/src/lib/libzpool/common/kernel.c	2012-07-30 16:07:06.939607123 +0400
+++ new/usr/src/lib/libzpool/common/kernel.c	2012-07-30 16:07:06.403607110 +0400
@@ -256,14 +256,21 @@
 	VERIFY(cond_destroy(cv) == 0);
 }
 
-void
-cv_wait(kcondvar_t *cv, kmutex_t *mp)
+int
+cv_wait_sig(kcondvar_t *cv, kmutex_t *mp)
 {
 	ASSERT(mutex_owner(mp) == curthread);
 	mp->m_owner = NULL;
 	int ret = cond_wait(cv, &mp->m_lock);
 	VERIFY(ret == 0 || ret == EINTR);
 	mp->m_owner = curthread;
+	return (ret == EINTR ? 0 : 1);
+}
+
+void
+cv_wait(kcondvar_t *cv, kmutex_t *mp)
+{
+	(void) cv_wait_sig(cv, mp);
 }
 
 clock_t
